//+------------------------------------------------------------------+
//|                                         FXstreet_Calendar_v2.mq4 |
//|                             Copyright  2007-12, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007-12, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"


#property indicator_chart_window

#include <stdlib.mqh>

#import "kernel32.dll"
void GetLocalTime(int& TimeArray[]);
void GetSystemTime(int& TimeArray[]);
int  GetTimeZoneInformation(int& TZInfoArray[]);
#import


extern string     CalendarName     = "FXstreet.com";
extern bool       UseAutoTimeZone  =    true; // Auto TimeZone Detection for Broker  
extern int        TimeZone         =       3; // Manual Time Zone setting      
  
extern bool       AlertMode        =   false;
extern int        AlertTimeGap     =       1; // Time Gap between News Time and Alert Time in min 
extern bool       PrintInLog       =   false;
extern bool       DisplayLine      =    true; // Display Line Option (Visualization mode) 
extern bool       DisplayText      =   false; // Display Text Option (Visualization mode)
extern int        LineStyle        =       3;

extern string     countryFilter    = " Country Filter: ";

extern color      UnitedStates     =    Blue; // None-off, color-on  
extern color      EMU              =    Pink;
extern color      UK               =    Red;
extern color      Japan            =    Orange;
extern color      Australia        =    Green;
extern color      NewZealand       =    Gray;
extern color      Canada           =    Tomato;
extern color      Switzerland      =    Magenta;

extern color      Germany          =    Pink;
extern color      France           =    Pink;
extern color      Italy            =    Pink;
extern color      Spain            =    Pink;
extern color      Netherlands      =    Pink;
extern color      Belgium          =    Pink;
extern color      Austria          =    Pink;
extern color      Greece           =    Pink;
extern color      Sweden           =    Pink;
extern color      Denmark          =    Pink;
extern color      Finland          =    Pink;
extern color      Norway           =    Pink;
extern color      Iceland          =    Pink;
extern color      Ireland          =    Pink;
extern color      Portugal         =    Pink;
extern color      Czech            =    Pink;
extern color      Slovakia         =    Pink;
extern color      Poland           =    Pink;
extern color      Hungary          =    Pink;
extern color      Romania          =    Pink;
extern color      Lithuania        =    Pink;
extern color      Latvia           =    Pink;
extern color      Estonia          =    Pink;
extern color      Turkey           =    Pink;
extern color      Russia          =     White;

extern color      China            =    Orange;
extern color      SouthKorea       =    Orange;
extern color      HongKong         =    Orange;
extern color      Indonesia        =    Orange;
extern color      Singapore        =    Orange;
extern color      India            =    Orange;
extern color      Qatar            =    Orange;

extern color      Brazil           =    Lime;
extern color      Argentina        =    Lime;
extern color      Chile            =    Lime;
extern color      Mexico           =    Lime;
extern color      Colombia         =    Lime;

extern color      SouthAfrica      =    Yellow;


extern string     ratingFilter     = " News Rating filter: ";
extern int        MaxRating        =       3; // Max News Rating = 3
extern int        MinRating        =       0; // Min News Rating = 0


extern string     graphSets        = " Graph Settings: ";  
extern int        window           =       0; // 0-chart window,1-1st subwindow,2-2nd subwindow and so on
extern int        step_X           =      20;
extern int        step_Y           =      20;
extern int        offset_X         =      20;
extern int        offset_Y         =      30;
extern string     textFontName     = "Bodoni MT";
extern string     headFontName     = "Bodoni MT Black";   
extern int        fontSize         =      10;
extern color      textColor        =    Silver;
extern color      timeColor        =      Gold;
extern color      NeutralColor     = SlateGray;
extern color      lowImpactColor   =    Yellow;
extern color      medImpactColor   =    Orange;
extern color      highImpactColor  = OrangeRed;            



string   sTime[];          // Time
string   sCountry[];       // Country
string   sDescription[];   // Description
string   sRating[];        // Rating
string   sActual[];        // Actual value
string   sForecast[];      // Forecast value
string   sPrevious[];      // Previous value

int      corner = 0;
datetime dt[]; 
string   sImpact[];
   
int      tz, NewsNum, counter;
bool     firstTime, firstTab;
datetime gmtime, prevWeekTime, nTime, OpenTime, tabTime, timeCur;
string   StartYear, uniqueName = "fxs";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
   firstTime = true;
   firstTab  = true;
   timeCur   = TimeCurrent();
//----
   return(0);
}


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   ObjectDel(uniqueName);  
   //ObjectDel(nameText);
   //ObjectDel(nameTab); 
   //Comment("");  
   return(0);
}
//----

void ReadnPlotCalendar(string fName)
{    
   int i, k, handle;
   bool rates = false;
   string info;
   
   
   
   ArrayResize(sTime,0);
   ArrayResize(sCountry,0);
   ArrayResize(sDescription,0);
   ArrayResize(sRating,0);
   ArrayResize(sActual,0);
   ArrayResize(sForecast,0);
   ArrayResize(sPrevious,0);
      
   ArrayResize(dt,0);
   ArrayResize(sImpact,0);
    
   handle = FileOpen(fName,FILE_CSV|FILE_READ,';');
   if(handle < 1)
   {
   Print("File not found ", GetLastError());
   return(false);
   }
   else
   {
   i=0;
      while(!FileIsEnding(handle))
      {
      k = ArraySize(sTime);
   
      ArrayResize(sTime,k + 1);
      ArrayResize(sCountry,k + 1);
      ArrayResize(sDescription,k + 1);
      ArrayResize(sRating,k + 1);
      ArrayResize(sActual,k + 1);
      ArrayResize(sForecast,k + 1);
      ArrayResize(sPrevious,k + 1);
            
      ArrayResize(dt,k + 1);
      ArrayResize(sImpact,k + 1);
      
      sTime[i]        = FileReadString(handle);   // Time
      if(sTime[i] == "") continue;
      sCountry[i]     = FileReadString(handle);   // Country
      sDescription[i] = FileReadString(handle);   // Description
      sRating[i]      = FileReadString(handle);   // Rating
      sActual[i]      = FileReadString(handle);   // Actual value
      sForecast[i]    = FileReadString(handle);   // Forecast value
      sPrevious[i]    = FileReadString(handle);   // Previous value
                  
      int rating = StrToInteger(sRating[i]);
      
         switch(rating)
         { 
         case 0:     sImpact[i] = "0"; break;
         case 1:     sImpact[i] = "L"; break;
         case 2:     sImpact[i] = "M"; break;
         case 3:     sImpact[i] = "H"; break;   
         }
     
      rates = rating <= MaxRating && rating >= MinRating;
      
      if(!rates) continue;
      
      color clr = CLR_NONE;
      
      if(sCountry[i] == "US")
        if(UnitedStates < 0) continue; else clr = UnitedStates; 
      
      if(sCountry[i] == "EU")
        if(EMU           < 0) continue; else clr = EMU; 
      
      if(sCountry[i] == "UK")
        if(UK           < 0) continue; else clr = UK; 
      
      if(sCountry[i] == "JP") 
        if(Japan        < 0) continue; else clr = Japan; 
        
      if(sCountry[i] == "AU")
        if(Australia    < 0) continue; else clr = Australia; 
      
      if(sCountry[i] == "NZ")
        if(NewZealand   < 0) continue; else clr = NewZealand; 
                    
      if(sCountry[i] == "CA")
        if(Canada       < 0) continue; else clr = Canada; 
      
      if(sCountry[i] == "CH")
        if(Switzerland  < 0) continue; else clr = Switzerland; 
            
      if(sCountry[i] == "DE")
        if(Germany       < 0) continue; else clr = Germany; 
      
      if(sCountry[i] == "FR")
        if(France        < 0) continue; else clr = France; 
      
      if(sCountry[i] == "IT")
        if(Italy         < 0) continue; else clr = Italy; 
      
      if(sCountry[i] == "ES")
        if(Spain         < 0) continue; else clr = Spain; 
      
      if(sCountry[i] == "NL")
        if(Netherlands   < 0) continue; else clr = Netherlands; 
      
      if(sCountry[i] == "BE")
        if(Belgium       < 0) continue; else clr = Belgium; 
      
      if(sCountry[i] == "AT")
        if(Austria       < 0) continue; else clr = Austria; 
      
      if(sCountry[i] == "GR")
        if(Greece        < 0) continue; else clr = Greece; 
      
      if(sCountry[i] == "SE")
        if(Sweden        < 0) continue; else clr = Sweden; 
      
      if(sCountry[i] == "DK")
        if(Denmark       < 0) continue; else clr = Denmark; 
      
      if(sCountry[i] == "FI")
        if(Finland       < 0) continue; else clr = Finland; 
      
      if(sCountry[i] == "NO")
        if(Norway        < 0) continue; else clr = Norway; 
      
      if(sCountry[i] == "IS")
        if(Iceland       < 0) continue; else clr = Iceland; 
      
      if(sCountry[i] == "IE")
        if(Ireland       < 0) continue; else clr = Ireland; 
      
      if(sCountry[i] == "PT")
        if(Portugal      < 0) continue; else clr = Portugal; 
      
      if(sCountry[i] == "CZ")
        if(Czech         < 0) continue; else clr = Czech; 
      
      if(sCountry[i] == "SL") //???
        if(Slovakia      < 0) continue; else clr = Slovakia; 
      
      if(sCountry[i] == "PL")
        if(Poland        < 0) continue; else clr = Poland; 
      
      if(sCountry[i] == "HU")
        if(Hungary       < 0) continue; else clr = Hungary; 
      
      if(sCountry[i] == "RO")
        if(Romania       < 0) continue; else clr = Romania; 
      
      if(sCountry[i] == "LT")
        if(Lithuania     < 0) continue; else clr = Lithuania; 
      
      if(sCountry[i] == "LV")
        if(Latvia        < 0) continue; else clr = Latvia; 
      
      if(sCountry[i] == "EE") //???
        if(Estonia       < 0) continue; else clr = Estonia; 
      
      if(sCountry[i] == "TR")
        if(Turkey        < 0) continue; else clr = Turkey; 
      
      if(sCountry[i] == "RU")
        if(Russia        < 0) continue; else clr = Russia; 
          
      if(sCountry[i] == "CN")
        if(China         < 0) continue; else clr = China; 
      
      if(sCountry[i] == "KR")
        if(SouthKorea    < 0) continue; else clr = SouthKorea; 
      
      if(sCountry[i] == "HK")
        if(HongKong      < 0) continue; else clr = HongKong; 
      
      if(sCountry[i] == "ID")
        if(Indonesia     < 0) continue; else clr = Indonesia; 
      
      if(sCountry[i] == "SG")
        if(Singapore     < 0) continue; else clr = Singapore; 
      
      if(sCountry[i] == "IN") //???
        if(India         < 0) continue; else clr = India; 
      
      if(sCountry[i] == "QA")
        if(Qatar         < 0) continue; else clr = Qatar; 
      
      if(sCountry[i] == "BR")
        if(Brazil        < 0) continue; else clr = Brazil; 
      
      if(sCountry[i] == "AR")
        if(Argentina     < 0) continue; else clr = Argentina; 
      
      if(sCountry[i] == "CL")
        if(Chile         < 0) continue; else clr = Chile; 
      
      if(sCountry[i] == "MX")
        if(Mexico        < 0) continue; else clr = Mexico; 
      
      if(sCountry[i] == "CO") 
        if(Colombia      < 0) continue; else clr = Colombia; 
      
      if(sCountry[i] == "ZA") 
        if(SouthAfrica   < 0) continue; else clr = SouthAfrica; 
      
      datetime eventtime = StrToTime(sTime[i]);           
      if(TimeToStr(eventtime,TIME_MINUTES) == "00:00" && rating == 0) dt[i] = eventtime; else dt[i] = eventtime + tz*3600;
      
      info  = TimeToStr(dt[i]) + " " + sCountry[i] + " "  + sDescription[i] + " " + sImpact[i] + " " + sActual[i] + " " + sForecast[i] + " " + sPrevious[i];
                    
      if(PrintInLog) Print(i + " " + info);
                  
         
         if(DisplayLine)
         {         
         ObjectCreate (uniqueName+"line"+i,OBJ_VLINE,window,dt[i],Close[0]);
         ObjectSetText(uniqueName+"line"+i,info,8);   
         ObjectSet    (uniqueName+"line"+i,OBJPROP_COLOR,clr);                    
         ObjectSet    (uniqueName+"line"+i,OBJPROP_STYLE,LineStyle);                    
         ObjectSet    (uniqueName+"line"+i,OBJPROP_BACK,true);          
         }
  
         if(DisplayText)
         {
         ObjectCreate (uniqueName+"text"+i,OBJ_TEXT,window,dt[i],Close[0]);
         ObjectSetText(uniqueName+"text",info,8);          
         ObjectSet    (uniqueName+"text",OBJPROP_COLOR, clr); 
         ObjectSet    (uniqueName+"text",OBJPROP_ANGLE, 90);          
         }
                 
      i++;
      }
   NewsNum = i;
   }
   return(0);
}


datetime GetWeekStart(datetime date) 
{ 
   int weekday = TimeDayOfWeek(date); 
   //if(weekday == 0) weekday = 7; 
   datetime start = date; 
     
   for (int i=weekday;i>0;i--) start = decDateOnDay(start); 
   
   return(start);
}

datetime decDateOnDay(datetime dt) 
{ 
  int ty = TimeYear(dt); 
  int tm = TimeMonth(dt); 
  int td = TimeDay(dt); 
  int th = TimeHour(dt); 
  int ti = TimeMinute(dt); 
    
   td--; 
   if(td == 0) 
   { 
   tm--; 
      if(tm == 0) 
      { 
      ty--; 
      tm = 12; 
      } 
    
   if(tm == 1 || tm == 3 || tm == 5 || tm == 7 || tm == 8 || tm == 10 || tm == 12) td = 31; 
   if(tm == 2) if(MathMod(ty,4) == 0) td = 29; else td = 28; 
   if(tm == 4 || tm == 6 || tm == 9 || tm == 11) td = 30; 
   } 
  
   return(StrToTime(ty+"."+tm+"."+td));//+" "+th+":"+ti)); 
}

string FXstreet_Calendar()
{
   datetime StartWeek = GetWeekStart(gmtime);// + tz*3600);
   
   string strStartWeek = TimeToStr(StartWeek);
      
   StartYear  = TimeYear (StartWeek);
   if(TimeMonth(StartWeek) > 9) string StartMonth = TimeMonth(StartWeek); else StartMonth = "0" + TimeMonth(StartWeek);
   if(TimeDay  (StartWeek) > 9) string StartDay   = TimeDay  (StartWeek); else StartDay   = "0" + TimeDay  (StartWeek);
   
   string StartTime = StartYear+"-"+StartMonth+"-"+StartDay; 
   
   string CalName   = "FXstreet_" + StartTime;
   
   int handle = FileOpen(CalName + ".csv",FILE_READ|FILE_CSV,";");
   FileClose(handle);
   
   if(handle > 0) {Print(CalName + ".csv already exists!"); return(CalName);}     
      
   string WebAdress = "http://www.fxstreet.com/fundamental/economic-calendar/calendar.ics";
   
   string strICS = "";
	
	bool result = GrabWeb(WebAdress,strICS);
  
   if(result) 
   {
   handle = FileOpen(CalName + ".ics",FILE_CSV|FILE_WRITE,';');
         
      if(handle > 0)
      {
      FileWrite(handle, strICS);
      FileClose(handle);
      }
   }
   else CalName = "";
     
	Print("LoadWeek(",strStartWeek, "): converting ics to csv...");
	
	string strCSV = "";
	
	if(!ConvertICStoCSV(StartWeek,strICS,strCSV))
	{
	Print( "LoadWeek(",strStartWeek, "): converting error!" );
	return("");
	}


	Print( "LoadWeek(",strStartWeek, "): writing csv..." );
	handle = FileOpen(CalName + ".csv",FILE_WRITE|FILE_CSV);
	
	if(handle > 0)
	{
	FileWrite(handle,strCSV);
	FileClose(handle);
	}
	else
	{
	int _GetLastError = GetLastError();
	Print( "LoadWeek() - FileOpen() Error #", _GetLastError, "!" );
	return("");
	}

	Print("LoadWeek(",strStartWeek,"): OK!");

   return(CalName);   
}



//+------------------------------------------------------------------+
bool ConvertICStoCSV(datetime StartWeekTime, string ics, string& csv )
{
	int table_start	= StringFind(ics,"BEGIN:VCALENDAR",0);
	int table_end		= StringFind(ics,"END:VCALENDAR",table_start+1);
	
	if(table_start < 0 || table_end < 0)
	{
	Alert("ConvertICStoCSV(",TimeToStr(StartWeekTime,TIME_DATE),"): invalid ics format!");
	return(false);
	}
   
   
	int curr_event = StringFind(ics,"DTSTAMP:"  ,table_start);
	int next_event = StringFind(ics,"END:VEVENT",curr_event + 1);
      
	int events_count	= 0;
	string events[], tmp;

	while(curr_event >= 0 && curr_event < table_end)
	{
   ArrayResize(events,events_count+1);
   events[events_count] = StringSubstr(ics,curr_event,next_event - curr_event);
	events_count++;

	curr_event = StringFind(ics,"DTSTAMP:"  ,curr_event + 1);
	next_event = StringFind(ics,"END:VEVENT",curr_event + 1);
	}
 
	if(events_count <= 0)
	{
	Alert("ConvertICStoCSV(",TimeToStr(StartWeekTime,TIME_DATE),"): invalid ics format (no events in table)!");
	return(false);
	}

   int start, length;
   string times[], news[], impact[], country[], desc[], prev[], cons[]; 
   
   ArrayResize(  times,events_count);
   ArrayResize(   news,events_count);
   ArrayResize( impact,events_count);
   ArrayResize(country,events_count);
   ArrayResize(   desc,events_count);
   ArrayResize(   prev,events_count);
   ArrayResize(   cons,events_count);
   
	for(int i = 0;i < events_count;i++)
	{
	start      = StringLen("DTSTAMP:");
	length     = StringFind(events[i],"DTSTART",0) - StringLen("DTSTART") - 2;
	times[i]   = timeToNormal(StringSubstr(events[i],start,length));
	
	if(GetWeekStart(StrToTime(times[i])) > StartWeekTime) continue;  //+ tz*3600
	
	start      = StringFind(events[i],"SUMMARY:",0) + StringLen("SUMMARY:");
	length     = StringFind(events[i],"DESCRIPTION:",0) - start - 1;
	news [i]   = StringSubstr(events[i],start,length);
	
	start      = 0;
	length     = 2;
	country[i] = StringSubstr(news[i],start,length);
	if(country[i] == "EM") country[i] = "EU"; 
	
	start      = 4;
	length     = StringFind(news[i],"[V:",0) - start - 1;
	desc[i]    = StringSubstr(news[i],start,length);
	
	if(StringFind(desc[i],";",0) >= 0) desc[i] = changeString(i,desc[i],";",""); 
	
	start      = StringFind(news[i],"[V:",0) + StringLen("[V:") + 1;
	length     = StringFind(news[i],"/3]",0) - start;
	impact[i]  = StringSubstr(news[i],start,length);
	
	start      = StringFind(events[i],"Previous:",0) + StringLen("Previous:") + 1;
	   
	   if(start < 10) {prev[i] = "-"; cons[i] = "-";}
	   else
      { 
	   length   = StringFind(events[i],"For more information",0) - start - 6;
	   tmp      = StringSubstr(events[i],start,length); 
      if(i == 3) Print("tmp=",tmp);
      int x    = StringFind(tmp,"/ Consensus:",0);
         if(x >= 0)
	      {
	      prev [i] = StringSubstr(tmp,0,x - 1);
	      start    = x + StringLen("/ Consensus:") + 1;
	      cons [i] = StringSubstr(tmp,start,x - start);
	      }
	      else {prev [i] = tmp; cons[i] = "-";}
      }
	
	
	if(StringFind(prev[i],"€",0) >= 0) prev[i] = changeString(i,prev[i],"€","EUR"); 
   if(StringFind(prev[i],"¥" ,0) >= 0) prev[i] = changeString(i,prev[i],"¥" ,"JPY");
   if(StringFind(prev[i],"£" ,0) >= 0) prev[i] = changeString(i,prev[i],"£" ,"GBP");
   
   if(StringFind(cons[i],"€",0) >= 0) cons[i] = changeString(i,cons[i],"€","EUR"); 
   if(StringFind(cons[i],"¥" ,0) >= 0) cons[i] = changeString(i,cons[i],"¥" ,"JPY");
   if(StringFind(cons[i],"£" ,0) >= 0) cons[i] = changeString(i,cons[i],"£" ,"GBP");
  
	csv = csv + times[i] + ";" + country[i] + ";" + desc[i] + ";" + impact[i] + ";-;" + cons[i] + ";" + prev[i] + "\n";
   }	
 
	return(true);
}

string timeToNormal(string time)
{
   string year  = StringSubstr(time,0,4);
   string month = StringSubstr(time,4,2);
   string day   = StringSubstr(time,6,2);
   string hour  = StringSubstr(time,9,2);
   string min   = StringSubstr(time,11,2);
   
   return(year+"."+month+"."+day+" "+hour+":"+min);
}

string changeString(int cnt,string text,string tochange,string changeon) 
{
   int    start, length;
   string sign, value;
      
   start    = 0;
   length   = StringFind(text,tochange,0); 
   if(length > 0) sign = StringSubstr(text,start,length); else sign = "";
   
   start    = StringFind(text,tochange,0) + StringLen(tochange);
   length   = StringLen(text) - start; 
   value    = StringSubstr(text,start,length); 
      
   return(changeon + sign + value);
}



void calendarTable()
{
   string upcomCountry[], upcomNews[], upcomImpact[], upcomTime[], upcomActual[], upcomCons[], upcomPrev[]; 
   string nextCountry[] , nextNews[] , nextImpact[] , nextTime[] , nextActual[] , nextCons[] , nextPrev[] ; 
   string prevCountry[] , prevNews[] , prevImpact[] , prevTime[] , prevActual[] , prevCons[] , prevPrev[] ; 
   
   
   int prTime = 0, upTime = 0, nxTime = 0;
   int upcom  = 0, prev   = 0, next   = 0;
   
   for (int i=0; i <= NewsNum; i++)
   { 
      if((TimeCurrent() > dt[i-1] && TimeCurrent() <= dt[i]) || (upTime == dt[i] && TimeCurrent() <= dt[i]))
      {
         if(upTime == dt[i] && sDescription[i] != sDescription[i-1])   
         {
         ArrayResize(upcomCountry,upcom+1); 
         ArrayResize(upcomImpact ,upcom+1); 
         ArrayResize(upcomNews   ,upcom+1); 
         ArrayResize(upcomTime   ,upcom+1); 
         ArrayResize(upcomActual ,upcom+1); 
         ArrayResize(upcomCons   ,upcom+1);
         ArrayResize(upcomPrev   ,upcom+1);
          
         upcomCountry[upcom] = sCountry[i]; 
         upcomNews   [upcom] = sDescription[i];
         upcomImpact [upcom] = sImpact[i];
         upcomActual [upcom] = sActual[i];
         upcomCons   [upcom] = sForecast[i];
         upcomPrev   [upcom] = sPrevious[i];
         upcomTime   [upcom] = TimeToStr(upTime);  
         }
         else
         {
         upcom = 0;
         ArrayResize(upcomCountry,upcom+1); 
         ArrayResize(upcomImpact ,upcom+1); 
         ArrayResize(upcomNews   ,upcom+1); 
         ArrayResize(upcomTime   ,upcom+1); 
         ArrayResize(upcomActual ,upcom+1); 
         ArrayResize(upcomCons   ,upcom+1);
         ArrayResize(upcomPrev   ,upcom+1);
         
         upcomCountry[upcom] = sCountry[i]; 
         upcomNews   [upcom] = sDescription[i];
         upcomImpact [upcom] = sImpact[i];
         upcomActual [upcom] = sActual[i];
         upcomCons   [upcom] = sForecast[i];
         upcomPrev   [upcom] = sPrevious[i];
         upcomTime   [upcom] = TimeToStr(dt[i]);  
         }
      upcom++;
      upTime = dt[i];
      }   
      
      if(TimeCurrent() > dt[i-1] && dt[i-1] != 0)
      {
         if(prTime == dt[i-1] && sDescription[i-1] != sDescription[i-2])   
         {
         ArrayResize(prevCountry,prev+1); 
         ArrayResize(prevImpact ,prev+1); 
         ArrayResize(prevNews   ,prev+1); 
         ArrayResize(prevTime   ,prev+1); 
         ArrayResize(prevActual ,prev+1); 
         ArrayResize(prevCons   ,prev+1);
         ArrayResize(prevPrev   ,prev+1);
          
         prevCountry[prev] = sCountry[i-1]; 
         prevNews   [prev] = sDescription[i-1];
         prevImpact [prev] = sImpact[i-1];
         prevActual [prev] = sActual[i-1];
         prevCons   [prev] = sForecast[i-1];
         prevPrev   [prev] = sPrevious[i-1];
         prevTime   [prev] = TimeToStr(prTime);  
         }
         else
         {
         prev = 0;
         ArrayResize(prevCountry,prev+1); 
         ArrayResize(prevImpact ,prev+1); 
         ArrayResize(prevNews   ,prev+1); 
         ArrayResize(prevTime   ,prev+1); 
         ArrayResize(prevActual ,prev+1); 
         ArrayResize(prevCons   ,prev+1);
         ArrayResize(prevPrev   ,prev+1);
          
         prevCountry[prev] = sCountry[i-1]; 
         prevNews   [prev] = sDescription[i-1];
         prevImpact [prev] = sImpact[i-1];
         prevActual [prev] = sActual[i-1];
         prevCons   [prev] = sForecast[i-1];
         prevPrev   [prev] = sPrevious[i-1];
         prevTime   [prev] = TimeToStr(dt[i-1]);
         }
      
         if(i == 0) 
         {
         prevCountry[prev] = ""; 
         prevNews   [prev] = "";
         prevImpact [prev] = "";
         prevActual [prev] = "";
         prevCons   [prev] = "";
         prevPrev   [prev] = "";
         prevTime   [prev] = "";
         }  
      prev++;
      prTime = dt[i-1];
      }
      
      if(upTime > 0 && upTime < dt[i])
      {
         if(dt[i] > nxTime && nxTime > 0) break;
         if(nxTime == dt[i] && sDescription[i] != sDescription[i-1])
         {      
         ArrayResize(nextCountry,next+1); 
         ArrayResize(nextImpact ,next+1); 
         ArrayResize(nextNews   ,next+1); 
         ArrayResize(nextTime   ,next+1); 
         ArrayResize(nextActual ,next+1); 
         ArrayResize(nextCons   ,next+1);
         ArrayResize(nextPrev   ,next+1);
          
         nextCountry[next] = sCountry[i]; 
         nextNews   [next] = sDescription[i];
         nextImpact [next] = sImpact[i];
         nextActual [next] = sActual[i];
         nextCons   [next] = sForecast[i];
         nextPrev   [next] = sPrevious[i];
         nextTime   [next] = TimeToStr(nxTime);  
         }
         else
         {
         next = 0;
         ArrayResize(nextCountry,next+1); 
         ArrayResize(nextImpact ,next+1); 
         ArrayResize(nextNews   ,next+1); 
         ArrayResize(nextTime   ,next+1); 
         ArrayResize(nextActual ,next+1); 
         ArrayResize(nextCons   ,next+1);
         ArrayResize(nextPrev   ,next+1);
          
         nextCountry[next] = sCountry[i]; 
         nextNews   [next] = sDescription[i];
         nextImpact [next] = sImpact[i];
         nextActual [next] = sActual[i];
         nextCons   [next] = sForecast[i];
         nextPrev   [next] = sPrevious[i];
         nextTime   [next] = TimeToStr(dt[i]);
         }
      
      next++;
      nxTime = dt[i];
      }
   }
   
   string tabname = uniqueName+"tab";
       
   if(firstTab || tabTime != StrToTime(upcomTime[0])) {ObjectDel(tabname); firstTab = false; tabTime = StrToTime(upcomTime[0]);}
   else return(0);  
   
   int x = offset_X, y = offset_Y;
       
   plotObject(tabname+" calname1"  ,window,corner,x                ,y,"FX"    ,fontSize+3,headFontName,false,textColor);
	plotObject(tabname+" calname2"  ,window,corner,x +(fontSize+3)*2,y,"STREET",fontSize+3,headFontName,false,Coral );
	plotObject(tabname+" calname3"  ,window,corner,x +(fontSize+3)*8,y,".COM"  ,fontSize+3,headFontName,false,textColor);
	
	y += step_Y; 
	if(tz >= 0) string sign = "+ "; else sign = "- ";
	plotObject(tabname+" calname "  ,window,corner,x,y,"Economic Calendar for GMT " + sign + DoubleToStr(MathAbs(tz),0),fontSize+1,textFontName,false,textColor);
		
	y += step_Y;
	plotObject(tabname+" header"   ,window,corner,x+fontSize*5,y,"N E W S :",fontSize+1,headFontName,false,textColor);
	
	y += 1.2*step_Y; 
   plotObject(tabname+" previous ",window,corner,x            ,y,CharToStr(149)+ " Previous :",fontSize,headFontName,false,textColor);
   plotObject(tabname+" prevtime ",window,corner,x+fontSize*10,y,prevTime[0]                  ,fontSize,headFontName,false,timeColor);
   
   string pimpact = "-";
   color  pcolor = CLR_NONE;
   
      for(i=0;i<prev;i++)
      {
      y += step_Y;
	
      ImpactView(prevImpact[i],pimpact,pcolor);	

      plotObject(tabname+" prevcountry "+i,window,corner,x             ,y,prevCountry[i],fontSize,textFontName,false,pcolor);      
      plotObject(tabname+" previmpact " +i,window,corner,x+fontSize*2.5,y,pimpact       ,fontSize,headFontName,false,pcolor);
      plotObject(tabname+" prevnews "   +i,window,corner,x+fontSize*5.0,y,prevNews[i]   ,fontSize,textFontName,false,pcolor);
	
      y += 0.7*step_Y;
      plotObject(tabname+" prevvalue "  +i,window,corner,x + 50,y,"Forecast :"+prevCons[i]+" Previous: "+prevPrev[i],fontSize,textFontName,false,pcolor);
      }
   
   y += 1.2*step_Y; 
   plotObject(tabname+"tab"+" upcoming ",window,corner,x            ,y,CharToStr(149)+" Upcoming :",fontSize,headFontName,false,textColor);
   plotObject(tabname+"tab"+" upcomtime",window,corner,x+fontSize*10,y,upcomTime[0]                ,fontSize,headFontName,false,timeColor);
   
   string uimpact = "-";
   color  ucolor = CLR_NONE;
         
      for(i=0;i<upcom;i++)
      {
      y += step_Y;
		
      ImpactView(upcomImpact[i],uimpact,ucolor);	
	
      plotObject(tabname+" upcountry "+i,window,corner,x             ,y,upcomCountry[i],fontSize,textFontName,false,ucolor);      
      plotObject(tabname+" upimpact " +i,window,corner,x+fontSize*2.5,y,uimpact        ,fontSize,headFontName,false,ucolor);
      plotObject(tabname+" upnews "   +i,window,corner,x+fontSize*5.0,y,upcomNews[i]   ,fontSize,textFontName,false,ucolor);
	
      y += 0.7*step_Y;
      plotObject(tabname+" upvalue "  +i,window,corner,x + 50,y,"Forecast :"+upcomCons[i]+" Previous: "+upcomPrev[i],fontSize,textFontName,false,ucolor);
      }
   
   y += 1.2*step_Y; 
   plotObject(tabname+" next "    ,window,corner,x            ,y,CharToStr(149)+" Next :" ,fontSize,headFontName,false,textColor);
   plotObject(tabname+" nexttime" ,window,corner,x+fontSize*10,y,nextTime[0],fontSize,headFontName,false,timeColor);
   
   string nimpact = "-";
   color  ncolor = CLR_NONE;
   
      for(i=0;i<next;i++)
      {
      y += step_Y;
	  
      ImpactView(nextImpact[i],nimpact,ncolor);	
	
      plotObject(tabname+" nxcountry " + i,window,corner,x             ,y,nextCountry[i],fontSize,textFontName,false,ncolor);      
      plotObject(tabname+" nximpact  " + i,window,corner,x+fontSize*2.5,y,nimpact       ,fontSize,headFontName,false,ncolor);
      plotObject(tabname+" nxnews    " + i,window,corner,x+fontSize*5.0,y,nextNews[i]   ,fontSize,textFontName,false,ncolor);
	
      y += 0.7*step_Y;
      plotObject(tabname+" nxvalue "  +i,window,corner,x + 50,y,"Forecast :"+nextCons[i]+" Previous: "+nextPrev[i],fontSize,textFontName,false,ncolor);
      }
}      

string ImpactView(string imp,string& sym,color& clr)
{
   if(imp == "L") {sym = "!"  ; clr = Yellow;   }  
	if(imp == "M") {sym = "!!" ; clr = Orange;   }
	if(imp == "H") {sym = "!!!"; clr = OrangeRed;}
   if(imp == "0") {sym = " "  ; clr = Silver;   }
}



bool ObjectDel(string name)
{
   int _GetLastError = 0;
     
   while(ObjFind(name,0,0) > 0)
   {
      int obtotal = ObjectsTotal();
      
      for (int i = 0; i < obtotal;i++)
      {
         if (StringFind(ObjectName(i),name,0) >= 0)
         {
            if (!ObjectDelete(ObjectName(i)))
            {
            _GetLastError = GetLastError();
            Print( "ObjectDelete( \"",ObjectName(i),"\" ) - Error #", _GetLastError );
            }
         }
      }
   }      
}
//-----
int ObjFind(string name,int start, int num)
{
   int cnt = 0;
   
   for (int i = 0; i < ObjectsTotal();i++)
      if (StringFind(ObjectName(i),name,start) == num) cnt+=1;
   
   return(cnt);
}



bool TimeToAlert()
{
   bool result = false;
   for (int i=0; i<=NewsNum; i++)
   { 
   datetime AlertTime = dt[i] - AlertTimeGap*60;
   
      if((TimeCurrent()>= AlertTime && TimeCurrent() <= AlertTime + 60))
      {result=true; break;}
   }
   return(result);
}


string GMT(int mode)
{  
   int    TimeArray[4];
   int    TZInfoArray[43];
   int    nYear,nMonth,nDay,nHour,nMin,nSec,nMilliSec;
   string sMilliSec, time_string;
//----
   if(mode == 0)
   {
   GetSystemTime(TimeArray);
//---- parse date and time from array
   nYear  = TimeArray[0]&0x0000FFFF;
   nMonth = TimeArray[0]>>16;
   nDay   = TimeArray[1]>>16;
   nHour  = TimeArray[2]&0x0000FFFF;
   nMin   = TimeArray[2]>>16;
   nSec   = TimeArray[3]&0x0000FFFF;
//---- format date and time items
   time_string = FormatDateTime(nYear,nMonth,nDay,nHour,nMin,nSec);
   return(time_string);
   }
   
//----
   if(mode > 0)
   {
   GetLocalTime(TimeArray);
//---- parse date and time from array
   nYear  = TimeArray[0]&0x0000FFFF;
   nMonth = TimeArray[0]>>16;
   nDay   = TimeArray[1]>>16;
   nHour  = TimeArray[2]&0x0000FFFF;
   nMin   = TimeArray[2]>>16;
   nSec   = TimeArray[3]&0x0000FFFF;
   
//---- format date and time items
   time_string = FormatDateTime(nYear,nMonth,nDay,nHour,nMin,nSec);
   
   if(mode == 1) return(time_string);
   
//---- shift with daylight savings
   int ret = GetTimeZoneInformation(TZInfoArray);
   int gmt_shift=0;
   
   if(ret != 0) gmt_shift = TZInfoArray[0];
   if(ret == 2) gmt_shift += TZInfoArray[42];
//---- GMT
   datetime local_time = StrToTime(time_string);
   
   time_string = TimeToStr(local_time+gmt_shift*60,TIME_DATE|TIME_SECONDS);
   
   if(mode == 2) return(time_string);
//---- winter time (nYear remains the current)
   nYear  = TimeArray[0]&0x0000FFFF;
   nMonth = TZInfoArray[17]>>16;
   nDay   = TZInfoArray[18]>>16;
   nHour  = TZInfoArray[19]&0x0000FFFF;
   nMin   = TZInfoArray[19]>>16;
   nSec   = TZInfoArray[20]&0x0000FFFF;
   
   time_string = FormatDateTime(nYear,nMonth,nDay,nHour,nMin,nSec);
   
   if(mode == 3) return(time_string);
//---- summer time (nYear remains the current)
   nYear  = TimeArray[0]&0x0000FFFF;
   nMonth = TZInfoArray[38]>>16;
   nDay   = TZInfoArray[39]>>16;
   nHour  = TZInfoArray[40]&0x0000FFFF;
   nMin   = TZInfoArray[40]>>16;
   nSec   = TZInfoArray[41]&0x0000FFFF;
   
   time_string = FormatDateTime(nYear,nMonth,nDay,nHour,nMin,nSec);

   if(mode == 4) return(time_string);
//----
   }
}

string FormatDateTime(int nYear,int nMonth,int nDay,int nHour,int nMin,int nSec)
{
   string sMonth,sDay,sHour,sMin,sSec;
//----
   sMonth = 100 + nMonth;
   sMonth = StringSubstr(sMonth,1);
   sDay   = 100 + nDay;
   sDay   = StringSubstr(sDay,1);
   sHour  = 100 + nHour;
   sHour  = StringSubstr(sHour,1);
   sMin   = 100 + nMin;
   sMin   = StringSubstr(sMin,1);
   sSec   = 100 + nSec;
   sSec   = StringSubstr(sSec,1);
//----
   return(StringConcatenate(nYear,".",sMonth,".",sDay," ",sHour,":",sMin,":",sSec));
}   


void plotObject(string name,int win,int corner,int X,int Y,string text,int size,string font,bool back,color clr)
{
   ObjectCreate(name,OBJ_LABEL,win,0,0,0,0);
   ObjectSet(name,OBJPROP_CORNER,corner);
   ObjectSet(name,OBJPROP_XDISTANCE,X);
   ObjectSet(name,OBJPROP_YDISTANCE,Y);
   ObjectSetText(name,text,size,font,clr);
   ObjectSet(name,OBJPROP_BACK,back);
}

//+---------------------------------------------------------------------------+
//|                                                               WinInet.mqh |
//|                                                        Paul Hampton-Smith |
//|                                                        paul1000@pobox.com |
//|                                                                           |
//| This include has been adapted from the groundbreaking GrabWeb script      |
//| developed by Adbi that showed me how to import functions from wininet.dll |
//|---------------------------------------------------------------------------|
//|                                                               grabweb.mq4 |
//|                                                    Copyright  2006, Abhi |
//|                                         http://www.megadelfi.com/experts/ |
//|                                     E-mail: grabwebexpert{Q)megadelfi.com |
//|                                fix my e-mail address before mailing me ;) |
//+---------------------------------------------------------------------------+
// Main Webscraping function
// ~~~~~~~~~~~~~~~~~~~~~~~~~
// bool GrabWeb(string strUrl, string& strWebPage)
// returns the text of any webpage. Returns false on timeout or other error
bool bWinInetDebug = false;

int hSession_IEType;
int hSession_Direct;
int Internet_Open_Type_Preconfig = 0;
int Internet_Open_Type_Direct = 1;
int Internet_Open_Type_Proxy = 3;
int Buffer_LEN = 80;

#define INTERNET_FLAG_PRAGMA_NOCACHE    0x00000100 // Forces the request to be resolved by the origin server, even if a cached copy exists on the proxy.
#define INTERNET_FLAG_NO_CACHE_WRITE    0x04000000 // Does not add the returned entity to the cache. 
#define INTERNET_FLAG_RELOAD            0x80000000 // Forces a download of the requested file, object, or directory listing from the origin server, not from the cache.
#define INTERNET_FLAG_NO_COOKIES			 0x00080000 // Does not automatically add cookie headers to requests, and does not automatically add returned cookies to the cookie database.

#import "wininet.dll"
	int InternetOpenA(
		string 	sAgent,
		int		lAccessType,
		string 	sProxyName="",
		string 	sProxyBypass="",
		int 	lFlags=0
	);
	int InternetOpenUrlA(
		int 	hInternetSession,
		string 	sUrl, 
		string 	sHeaders="",
		int 	lHeadersLength=0,
		int 	lFlags=0,
		int 	lContext=0 
	);
	int InternetReadFile(
		int 	hFile,
		string 	sBuffer,
		int 	lNumBytesToRead,
		int& 	lNumberOfBytesRead[]
	);
	int InternetCloseHandle(
		int 	hInet
	);
#import


bool GrabWeb(string strUrl, string& strWebPage)
{
	int 		hInternet;
	int		iResult;
	int 		lReturn[]	= {1};
	string 	sBuffer		= "                                                                                                                                                                                                                                                               ";	// 255 spaces
	int 		bytes;
	
	hInternet = InternetOpenUrlA(hSession(FALSE), strUrl, "0", 0, 
								INTERNET_FLAG_NO_CACHE_WRITE | 
								INTERNET_FLAG_PRAGMA_NOCACHE | 
								INTERNET_FLAG_RELOAD			  |
								INTERNET_FLAG_NO_COOKIES, 0);

	if (bWinInetDebug) 
		Print("hInternet: " + hInternet);   
	if (hInternet == 0) 
		return(false);

	iResult = InternetReadFile(hInternet, sBuffer, Buffer_LEN, lReturn);
	
	if (bWinInetDebug) 
		Print("iResult: " + iResult);
	if (bWinInetDebug) 
		Print("lReturn: " + lReturn[0]);
	if (bWinInetDebug) 
		Print("iResult: " + iResult);
	if (bWinInetDebug) 
		Print("sBuffer: " +  sBuffer);
	if (iResult == 0) 
		return(false);
	bytes = lReturn[0];

	strWebPage = StringSubstr(sBuffer, 0, lReturn[0]);
	
// If there's more data then keep reading it into the buffer
	while (lReturn[0] != 0)
	{
		iResult = InternetReadFile(hInternet, sBuffer, Buffer_LEN, lReturn);
		if (lReturn[0]==0) 
			break;
		bytes = bytes + lReturn[0];
		strWebPage = strWebPage + StringSubstr(sBuffer, 0, lReturn[0]);
	}

	iResult = InternetCloseHandle(hInternet);
	if (iResult == 0) 
		return(false);
		
	return(true);
}

int hSession(bool Direct)
{
	string InternetAgent;

	if(hSession_IEType == 0)
	{
	InternetAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; Q312461)";
	hSession_IEType = InternetOpenA(InternetAgent, Internet_Open_Type_Preconfig, "0", "0", 0);
	hSession_Direct = InternetOpenA(InternetAgent, Internet_Open_Type_Direct, "0", "0", 0);
	}
	
	if(Direct) return(hSession_Direct); else return(hSession_IEType); 
}



//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   if(counter < 5) {counter++; return(0);}
   datetime currentWeekTime = iTime(NULL,PERIOD_W1,0);
            
   if(TimeCurrent() - currentWeekTime > PERIOD_W1*60) return(0);
 
   if(firstTime || (TimeCurrent() > currentWeekTime && currentWeekTime > prevWeekTime))
   {
   string gmt = GMT(0); 
   if(gmt != "") gmtime = StrToTime(gmt); else return(0);
   
   if(UseAutoTimeZone) tz = MathMin(NormalizeDouble((TimeCurrent() - gmtime)/3600.0,0),24); else tz = TimeZone; 
   Print("gmt=",gmt," tz=",tz," tc=",TimeToStr(TimeCurrent())," t1=",TimeToStr(Time[0])," tc=",TimeToStr(TimeLocal()));
   
   string calName = FXstreet_Calendar();
   
      if(calName != "")
      {   
      ReadnPlotCalendar(calName+".csv");
      firstTime = false;
      prevWeekTime = currentWeekTime;
      }
      else return(0);
   }
   
   if(AlertMode && TimeToAlert() && TimeCurrent() > nTime) 
   {
   Alert("Upcoming News! Be ready!"); 
   nTime = TimeCurrent() + AlertTimeGap*60;
   }
   
   
   calendarTable(); 
     
   WindowRedraw();
   
   Sleep(1000);
//----

   return(0);
}
//+------------------------------------------------------------------+


